
/* ex: set ro:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'nqp_bigint.ops' (and possibly other
 * .ops files). by ops2c.nqp.
 *
 * Any changes made here will be lost!  To regenerate this file after making
 * changes to any ops, use the bootstrap-ops makefile target.
 *
 */
#define PARROT_IN_EXTENSION

#include "nqp_bigint_ops.h"
#include "pmc/pmc_parrotlibrary.h"
#include "pmc/pmc_callcontext.h"


/* defines - Ops::Trans::C */
#define REL_PC     ((size_t)(cur_opcode - (opcode_t *)interp->code->base.data))
#define CUR_OPCODE cur_opcode
#define IREG(i) REG_INT(interp, cur_opcode[i])
#define NREG(i) REG_NUM(interp, cur_opcode[i])
#define PREG(i) REG_PMC(interp, cur_opcode[i])
#define SREG(i) REG_STR(interp, cur_opcode[i])
#define ICONST(i) cur_opcode[i]
#define NCONST(i) Parrot_pcc_get_num_constants(interp, interp->ctx)[cur_opcode[i]]
#define SCONST(i) Parrot_pcc_get_str_constants(interp, interp->ctx)[cur_opcode[i]]
#undef  PCONST
#define PCONST(i) Parrot_pcc_get_pmc_constants(interp, interp->ctx)[cur_opcode[i]]

static int get_op(PARROT_INTERP, const char * name, int full);


/* XXX should be static, but C++ doesn't want to play ball */
extern op_lib_t nqp_bigint_op_lib;



/* Parroty includes. */
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "../6model/sixmodelobject.h"
#include "../6model/reprs/P6bigint.h"

/* The ID of the bigint REPR. */
static INTVAL bigint_repr_id = 0;

static mp_int * get_bigint(PARROT_INTERP, PMC *obj) {
    struct SixModel_REPROps *r = REPR(obj);
    if (r->ID == bigint_repr_id)
        return &((P6bigintInstance *)PMC_data(obj))->body.i;
    else
        return &((P6bigintBody *)r->box_funcs->get_boxed_ref(interp, STABLE(obj), OBJECT_BODY(obj),
            bigint_repr_id))->i;
}

static FLOATVAL mp_get_double(mp_int *a) {
    FLOATVAL d    = 0.0;
    FLOATVAL sign = SIGN(a) == MP_NEG ? -1.0 : 1.0;
    int i;
    if (USED(a) == 0)
        return d;
    if (USED(a) == 1)
        return sign * (FLOATVAL) DIGIT(a, 0);

    mp_clamp(a);
    i = USED(a) - 1;
    d = (FLOATVAL) DIGIT(a, i);
    i--;
    if (i == -1) {
        return sign * d;
    }
    d *= pow(2.0, DIGIT_BIT);
    d += (FLOATVAL) DIGIT(a, i);

    d *= pow(2.0, DIGIT_BIT * i);
    return sign * d;
}


static void from_num(FLOATVAL d, mp_int *a) {
    FLOATVAL d_digit = pow(2, DIGIT_BIT);
    FLOATVAL da      = fabs(d);
    FLOATVAL upper;
    FLOATVAL lower;
    int      digits  = 0;

    mp_zero(a);

    while (da > d_digit * d_digit) {;
        da /= d_digit;
        digits++;
    }
    mp_grow(a, digits + 2);

    /* populate the top 2 digits */
    upper = da / d_digit;
    lower = fmod(da, d_digit);
    if (upper >= 1) {
        mp_set_long(a, (unsigned long) upper);
        mp_mul_2d(a, DIGIT_BIT , a);
    } else {
        a->used = 1;
    }
    DIGIT(a, 0) = (mp_digit) lower;

    /* shift the rest */
    mp_mul_2d(a, DIGIT_BIT * digits, a);
    if (d < 0)
        mp_neg(a, a);
    mp_clamp(a);
    mp_shrink(a);
}

static void grow_and_negate(mp_int *a, int size, mp_int *b) {
    int i;
    int actual_size = MAX(size, USED(a));
    mp_zero(b);
    mp_grow(b, actual_size);
    USED(b) = actual_size;
    for (i = 0; i < actual_size; i++) {
        DIGIT(b, i) = (~DIGIT(a, i)) & MP_MASK;
    }
    mp_add_d(b, 1, b);
}


static void two_complement_bitop(mp_int *a, mp_int *b, mp_int *c,
        int (*mp_bitop)(mp_int *, mp_int *, mp_int *)) {
    mp_int d;
    if (SIGN(a) ^ SIGN(b)) {
        /* exactly one of them is negative, so need to perform
         * some magic. tommath stores a sign bit, but Perl 6 expects
         * 2's complement */
        mp_init(&d);
        if (MP_NEG == SIGN(a)) {
            grow_and_negate(a, USED(b), &d);
            mp_bitop(&d, b, c);
        } else {
            grow_and_negate(b, USED(a), &d);
            mp_bitop(a, &d, c);
        }
        if (DIGIT(c, USED(c) - 1) & ((mp_digit)1<<(mp_digit)(DIGIT_BIT - 1))) {
            grow_and_negate(c, c->used, &d);
            mp_copy(&d, c);
            mp_neg(c, c);
        }
        mp_clear(&d);
    } else {
        mp_bitop(a, b, c);
    }

}




INTVAL nqp_bigint_numops = 226;

/*
** Op Function Table:
*/

static op_func_t nqp_bigint_op_func_table[226] = {
  Parrot_nqp_bigint_setup,                           /*      0 */
  Parrot_nqp_bigint_add_p_p_p_p,                     /*      1 */
  Parrot_nqp_bigint_add_p_pc_p_p,                    /*      2 */
  Parrot_nqp_bigint_add_p_p_pc_p,                    /*      3 */
  Parrot_nqp_bigint_add_p_pc_pc_p,                   /*      4 */
  Parrot_nqp_bigint_add_p_p_p_pc,                    /*      5 */
  Parrot_nqp_bigint_add_p_pc_p_pc,                   /*      6 */
  Parrot_nqp_bigint_add_p_p_pc_pc,                   /*      7 */
  Parrot_nqp_bigint_add_p_pc_pc_pc,                  /*      8 */
  Parrot_nqp_bigint_sub_p_p_p_p,                     /*      9 */
  Parrot_nqp_bigint_sub_p_pc_p_p,                    /*     10 */
  Parrot_nqp_bigint_sub_p_p_pc_p,                    /*     11 */
  Parrot_nqp_bigint_sub_p_pc_pc_p,                   /*     12 */
  Parrot_nqp_bigint_sub_p_p_p_pc,                    /*     13 */
  Parrot_nqp_bigint_sub_p_pc_p_pc,                   /*     14 */
  Parrot_nqp_bigint_sub_p_p_pc_pc,                   /*     15 */
  Parrot_nqp_bigint_sub_p_pc_pc_pc,                  /*     16 */
  Parrot_nqp_bigint_mul_p_p_p_p,                     /*     17 */
  Parrot_nqp_bigint_mul_p_pc_p_p,                    /*     18 */
  Parrot_nqp_bigint_mul_p_p_pc_p,                    /*     19 */
  Parrot_nqp_bigint_mul_p_pc_pc_p,                   /*     20 */
  Parrot_nqp_bigint_mul_p_p_p_pc,                    /*     21 */
  Parrot_nqp_bigint_mul_p_pc_p_pc,                   /*     22 */
  Parrot_nqp_bigint_mul_p_p_pc_pc,                   /*     23 */
  Parrot_nqp_bigint_mul_p_pc_pc_pc,                  /*     24 */
  Parrot_nqp_bigint_div_p_p_p_p,                     /*     25 */
  Parrot_nqp_bigint_div_p_pc_p_p,                    /*     26 */
  Parrot_nqp_bigint_div_p_p_pc_p,                    /*     27 */
  Parrot_nqp_bigint_div_p_pc_pc_p,                   /*     28 */
  Parrot_nqp_bigint_div_p_p_p_pc,                    /*     29 */
  Parrot_nqp_bigint_div_p_pc_p_pc,                   /*     30 */
  Parrot_nqp_bigint_div_p_p_pc_pc,                   /*     31 */
  Parrot_nqp_bigint_div_p_pc_pc_pc,                  /*     32 */
  Parrot_nqp_bigint_mod_p_p_p_p,                     /*     33 */
  Parrot_nqp_bigint_mod_p_pc_p_p,                    /*     34 */
  Parrot_nqp_bigint_mod_p_p_pc_p,                    /*     35 */
  Parrot_nqp_bigint_mod_p_pc_pc_p,                   /*     36 */
  Parrot_nqp_bigint_mod_p_p_p_pc,                    /*     37 */
  Parrot_nqp_bigint_mod_p_pc_p_pc,                   /*     38 */
  Parrot_nqp_bigint_mod_p_p_pc_pc,                   /*     39 */
  Parrot_nqp_bigint_mod_p_pc_pc_pc,                  /*     40 */
  Parrot_nqp_bigint_exp_mod_p_p_p_p_p,               /*     41 */
  Parrot_nqp_bigint_exp_mod_p_pc_p_p_p,              /*     42 */
  Parrot_nqp_bigint_exp_mod_p_p_pc_p_p,              /*     43 */
  Parrot_nqp_bigint_exp_mod_p_pc_pc_p_p,             /*     44 */
  Parrot_nqp_bigint_exp_mod_p_p_p_pc_p,              /*     45 */
  Parrot_nqp_bigint_exp_mod_p_pc_p_pc_p,             /*     46 */
  Parrot_nqp_bigint_exp_mod_p_p_pc_pc_p,             /*     47 */
  Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_p,            /*     48 */
  Parrot_nqp_bigint_exp_mod_p_p_p_p_pc,              /*     49 */
  Parrot_nqp_bigint_exp_mod_p_pc_p_p_pc,             /*     50 */
  Parrot_nqp_bigint_exp_mod_p_p_pc_p_pc,             /*     51 */
  Parrot_nqp_bigint_exp_mod_p_pc_pc_p_pc,            /*     52 */
  Parrot_nqp_bigint_exp_mod_p_p_p_pc_pc,             /*     53 */
  Parrot_nqp_bigint_exp_mod_p_pc_p_pc_pc,            /*     54 */
  Parrot_nqp_bigint_exp_mod_p_p_pc_pc_pc,            /*     55 */
  Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_pc,           /*     56 */
  Parrot_nqp_bigint_neg_p_p_p,                       /*     57 */
  Parrot_nqp_bigint_neg_p_pc_p,                      /*     58 */
  Parrot_nqp_bigint_neg_p_p_pc,                      /*     59 */
  Parrot_nqp_bigint_neg_p_pc_pc,                     /*     60 */
  Parrot_nqp_bigint_abs_p_p_p,                       /*     61 */
  Parrot_nqp_bigint_abs_p_pc_p,                      /*     62 */
  Parrot_nqp_bigint_abs_p_p_pc,                      /*     63 */
  Parrot_nqp_bigint_abs_p_pc_pc,                     /*     64 */
  Parrot_nqp_bigint_cmp_i_p_p,                       /*     65 */
  Parrot_nqp_bigint_cmp_i_pc_p,                      /*     66 */
  Parrot_nqp_bigint_cmp_i_p_pc,                      /*     67 */
  Parrot_nqp_bigint_cmp_i_pc_pc,                     /*     68 */
  Parrot_nqp_bigint_bool_i_p,                        /*     69 */
  Parrot_nqp_bigint_bool_i_pc,                       /*     70 */
  Parrot_nqp_bigint_eq_i_p_p,                        /*     71 */
  Parrot_nqp_bigint_eq_i_pc_p,                       /*     72 */
  Parrot_nqp_bigint_eq_i_p_pc,                       /*     73 */
  Parrot_nqp_bigint_eq_i_pc_pc,                      /*     74 */
  Parrot_nqp_bigint_ne_i_p_p,                        /*     75 */
  Parrot_nqp_bigint_ne_i_pc_p,                       /*     76 */
  Parrot_nqp_bigint_ne_i_p_pc,                       /*     77 */
  Parrot_nqp_bigint_ne_i_pc_pc,                      /*     78 */
  Parrot_nqp_bigint_gt_i_p_p,                        /*     79 */
  Parrot_nqp_bigint_gt_i_pc_p,                       /*     80 */
  Parrot_nqp_bigint_gt_i_p_pc,                       /*     81 */
  Parrot_nqp_bigint_gt_i_pc_pc,                      /*     82 */
  Parrot_nqp_bigint_ge_i_p_p,                        /*     83 */
  Parrot_nqp_bigint_ge_i_pc_p,                       /*     84 */
  Parrot_nqp_bigint_ge_i_p_pc,                       /*     85 */
  Parrot_nqp_bigint_ge_i_pc_pc,                      /*     86 */
  Parrot_nqp_bigint_lt_i_p_p,                        /*     87 */
  Parrot_nqp_bigint_lt_i_pc_p,                       /*     88 */
  Parrot_nqp_bigint_lt_i_p_pc,                       /*     89 */
  Parrot_nqp_bigint_lt_i_pc_pc,                      /*     90 */
  Parrot_nqp_bigint_le_i_p_p,                        /*     91 */
  Parrot_nqp_bigint_le_i_pc_p,                       /*     92 */
  Parrot_nqp_bigint_le_i_p_pc,                       /*     93 */
  Parrot_nqp_bigint_le_i_pc_pc,                      /*     94 */
  Parrot_nqp_bigint_gcd_p_p_p_p,                     /*     95 */
  Parrot_nqp_bigint_gcd_p_pc_p_p,                    /*     96 */
  Parrot_nqp_bigint_gcd_p_p_pc_p,                    /*     97 */
  Parrot_nqp_bigint_gcd_p_pc_pc_p,                   /*     98 */
  Parrot_nqp_bigint_gcd_p_p_p_pc,                    /*     99 */
  Parrot_nqp_bigint_gcd_p_pc_p_pc,                   /*    100 */
  Parrot_nqp_bigint_gcd_p_p_pc_pc,                   /*    101 */
  Parrot_nqp_bigint_gcd_p_pc_pc_pc,                  /*    102 */
  Parrot_nqp_bigint_lcm_p_p_p_p,                     /*    103 */
  Parrot_nqp_bigint_lcm_p_pc_p_p,                    /*    104 */
  Parrot_nqp_bigint_lcm_p_p_pc_p,                    /*    105 */
  Parrot_nqp_bigint_lcm_p_pc_pc_p,                   /*    106 */
  Parrot_nqp_bigint_lcm_p_p_p_pc,                    /*    107 */
  Parrot_nqp_bigint_lcm_p_pc_p_pc,                   /*    108 */
  Parrot_nqp_bigint_lcm_p_p_pc_pc,                   /*    109 */
  Parrot_nqp_bigint_lcm_p_pc_pc_pc,                  /*    110 */
  Parrot_nqp_bigint_from_str_p_s_p,                  /*    111 */
  Parrot_nqp_bigint_from_str_p_sc_p,                 /*    112 */
  Parrot_nqp_bigint_from_str_p_s_pc,                 /*    113 */
  Parrot_nqp_bigint_from_str_p_sc_pc,                /*    114 */
  Parrot_nqp_bigint_to_str_s_p,                      /*    115 */
  Parrot_nqp_bigint_to_str_s_pc,                     /*    116 */
  Parrot_nqp_bigint_to_str_base_s_p_i,               /*    117 */
  Parrot_nqp_bigint_to_str_base_s_pc_i,              /*    118 */
  Parrot_nqp_bigint_to_str_base_s_p_ic,              /*    119 */
  Parrot_nqp_bigint_to_str_base_s_pc_ic,             /*    120 */
  Parrot_nqp_bigint_to_num_n_p,                      /*    121 */
  Parrot_nqp_bigint_to_num_n_pc,                     /*    122 */
  Parrot_nqp_bigint_from_num_p_n_p,                  /*    123 */
  Parrot_nqp_bigint_from_num_p_nc_p,                 /*    124 */
  Parrot_nqp_bigint_from_num_p_n_pc,                 /*    125 */
  Parrot_nqp_bigint_from_num_p_nc_pc,                /*    126 */
  Parrot_nqp_bigint_div_num_n_p_p,                   /*    127 */
  Parrot_nqp_bigint_div_num_n_pc_p,                  /*    128 */
  Parrot_nqp_bigint_div_num_n_p_pc,                  /*    129 */
  Parrot_nqp_bigint_div_num_n_pc_pc,                 /*    130 */
  Parrot_nqp_bigint_shr_p_p_i_p,                     /*    131 */
  Parrot_nqp_bigint_shr_p_pc_i_p,                    /*    132 */
  Parrot_nqp_bigint_shr_p_p_ic_p,                    /*    133 */
  Parrot_nqp_bigint_shr_p_pc_ic_p,                   /*    134 */
  Parrot_nqp_bigint_shr_p_p_i_pc,                    /*    135 */
  Parrot_nqp_bigint_shr_p_pc_i_pc,                   /*    136 */
  Parrot_nqp_bigint_shr_p_p_ic_pc,                   /*    137 */
  Parrot_nqp_bigint_shr_p_pc_ic_pc,                  /*    138 */
  Parrot_nqp_bigint_shl_p_p_i_p,                     /*    139 */
  Parrot_nqp_bigint_shl_p_pc_i_p,                    /*    140 */
  Parrot_nqp_bigint_shl_p_p_ic_p,                    /*    141 */
  Parrot_nqp_bigint_shl_p_pc_ic_p,                   /*    142 */
  Parrot_nqp_bigint_shl_p_p_i_pc,                    /*    143 */
  Parrot_nqp_bigint_shl_p_pc_i_pc,                   /*    144 */
  Parrot_nqp_bigint_shl_p_p_ic_pc,                   /*    145 */
  Parrot_nqp_bigint_shl_p_pc_ic_pc,                  /*    146 */
  Parrot_nqp_bigint_band_p_p_p_p,                    /*    147 */
  Parrot_nqp_bigint_band_p_pc_p_p,                   /*    148 */
  Parrot_nqp_bigint_band_p_p_pc_p,                   /*    149 */
  Parrot_nqp_bigint_band_p_pc_pc_p,                  /*    150 */
  Parrot_nqp_bigint_band_p_p_p_pc,                   /*    151 */
  Parrot_nqp_bigint_band_p_pc_p_pc,                  /*    152 */
  Parrot_nqp_bigint_band_p_p_pc_pc,                  /*    153 */
  Parrot_nqp_bigint_band_p_pc_pc_pc,                 /*    154 */
  Parrot_nqp_bigint_bor_p_p_p_p,                     /*    155 */
  Parrot_nqp_bigint_bor_p_pc_p_p,                    /*    156 */
  Parrot_nqp_bigint_bor_p_p_pc_p,                    /*    157 */
  Parrot_nqp_bigint_bor_p_pc_pc_p,                   /*    158 */
  Parrot_nqp_bigint_bor_p_p_p_pc,                    /*    159 */
  Parrot_nqp_bigint_bor_p_pc_p_pc,                   /*    160 */
  Parrot_nqp_bigint_bor_p_p_pc_pc,                   /*    161 */
  Parrot_nqp_bigint_bor_p_pc_pc_pc,                  /*    162 */
  Parrot_nqp_bigint_bxor_p_p_p_p,                    /*    163 */
  Parrot_nqp_bigint_bxor_p_pc_p_p,                   /*    164 */
  Parrot_nqp_bigint_bxor_p_p_pc_p,                   /*    165 */
  Parrot_nqp_bigint_bxor_p_pc_pc_p,                  /*    166 */
  Parrot_nqp_bigint_bxor_p_p_p_pc,                   /*    167 */
  Parrot_nqp_bigint_bxor_p_pc_p_pc,                  /*    168 */
  Parrot_nqp_bigint_bxor_p_p_pc_pc,                  /*    169 */
  Parrot_nqp_bigint_bxor_p_pc_pc_pc,                 /*    170 */
  Parrot_nqp_bigint_bnot_p_p_p,                      /*    171 */
  Parrot_nqp_bigint_bnot_p_pc_p,                     /*    172 */
  Parrot_nqp_bigint_bnot_p_p_pc,                     /*    173 */
  Parrot_nqp_bigint_bnot_p_pc_pc,                    /*    174 */
  Parrot_nqp_bigint_radix_p_i_s_i_i_p,               /*    175 */
  Parrot_nqp_bigint_radix_p_ic_s_i_i_p,              /*    176 */
  Parrot_nqp_bigint_radix_p_i_sc_i_i_p,              /*    177 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_i_p,             /*    178 */
  Parrot_nqp_bigint_radix_p_i_s_ic_i_p,              /*    179 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_i_p,             /*    180 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_i_p,             /*    181 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p,            /*    182 */
  Parrot_nqp_bigint_radix_p_i_s_i_ic_p,              /*    183 */
  Parrot_nqp_bigint_radix_p_ic_s_i_ic_p,             /*    184 */
  Parrot_nqp_bigint_radix_p_i_sc_i_ic_p,             /*    185 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p,            /*    186 */
  Parrot_nqp_bigint_radix_p_i_s_ic_ic_p,             /*    187 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p,            /*    188 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p,            /*    189 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p,           /*    190 */
  Parrot_nqp_bigint_radix_p_i_s_i_i_pc,              /*    191 */
  Parrot_nqp_bigint_radix_p_ic_s_i_i_pc,             /*    192 */
  Parrot_nqp_bigint_radix_p_i_sc_i_i_pc,             /*    193 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_i_pc,            /*    194 */
  Parrot_nqp_bigint_radix_p_i_s_ic_i_pc,             /*    195 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_i_pc,            /*    196 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_i_pc,            /*    197 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_i_pc,           /*    198 */
  Parrot_nqp_bigint_radix_p_i_s_i_ic_pc,             /*    199 */
  Parrot_nqp_bigint_radix_p_ic_s_i_ic_pc,            /*    200 */
  Parrot_nqp_bigint_radix_p_i_sc_i_ic_pc,            /*    201 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_ic_pc,           /*    202 */
  Parrot_nqp_bigint_radix_p_i_s_ic_ic_pc,            /*    203 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_ic_pc,           /*    204 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_ic_pc,           /*    205 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_pc,          /*    206 */
  Parrot_nqp_bigint_pow_p_p_p_p_p,                   /*    207 */
  Parrot_nqp_bigint_pow_p_pc_p_p_p,                  /*    208 */
  Parrot_nqp_bigint_pow_p_p_pc_p_p,                  /*    209 */
  Parrot_nqp_bigint_pow_p_pc_pc_p_p,                 /*    210 */
  Parrot_nqp_bigint_pow_p_p_p_pc_p,                  /*    211 */
  Parrot_nqp_bigint_pow_p_pc_p_pc_p,                 /*    212 */
  Parrot_nqp_bigint_pow_p_p_pc_pc_p,                 /*    213 */
  Parrot_nqp_bigint_pow_p_pc_pc_pc_p,                /*    214 */
  Parrot_nqp_bigint_pow_p_p_p_p_pc,                  /*    215 */
  Parrot_nqp_bigint_pow_p_pc_p_p_pc,                 /*    216 */
  Parrot_nqp_bigint_pow_p_p_pc_p_pc,                 /*    217 */
  Parrot_nqp_bigint_pow_p_pc_pc_p_pc,                /*    218 */
  Parrot_nqp_bigint_pow_p_p_p_pc_pc,                 /*    219 */
  Parrot_nqp_bigint_pow_p_pc_p_pc_pc,                /*    220 */
  Parrot_nqp_bigint_pow_p_p_pc_pc_pc,                /*    221 */
  Parrot_nqp_bigint_pow_p_pc_pc_pc_pc,               /*    222 */
  Parrot_nqp_bigint_is_big_i_p,                      /*    223 */
  Parrot_nqp_bigint_is_big_i_pc,                     /*    224 */

  NULL /* NULL function pointer */
};



/*
** Op Info Table:
*/

static op_info_t nqp_bigint_op_info_table[226] = {
  { /* 0 */
    "nqp_bigint_setup",
    "nqp_bigint_setup",
    "Parrot_nqp_bigint_setup",
    0,
    1,
    { (arg_type_t) 0 },
    { (arg_dir_t) 0 },
    { 0 },
    &nqp_bigint_op_lib
  },
  { /* 1 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_p_p_p",
    "Parrot_nqp_bigint_add_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 2 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_pc_p_p",
    "Parrot_nqp_bigint_add_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 3 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_p_pc_p",
    "Parrot_nqp_bigint_add_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 4 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_pc_pc_p",
    "Parrot_nqp_bigint_add_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 5 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_p_p_pc",
    "Parrot_nqp_bigint_add_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 6 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_pc_p_pc",
    "Parrot_nqp_bigint_add_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 7 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_p_pc_pc",
    "Parrot_nqp_bigint_add_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 8 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_pc_pc_pc",
    "Parrot_nqp_bigint_add_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 9 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_p_p_p",
    "Parrot_nqp_bigint_sub_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 10 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_pc_p_p",
    "Parrot_nqp_bigint_sub_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 11 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_p_pc_p",
    "Parrot_nqp_bigint_sub_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 12 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_pc_pc_p",
    "Parrot_nqp_bigint_sub_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 13 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_p_p_pc",
    "Parrot_nqp_bigint_sub_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 14 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_pc_p_pc",
    "Parrot_nqp_bigint_sub_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 15 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_p_pc_pc",
    "Parrot_nqp_bigint_sub_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 16 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_pc_pc_pc",
    "Parrot_nqp_bigint_sub_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 17 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_p_p_p",
    "Parrot_nqp_bigint_mul_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 18 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_pc_p_p",
    "Parrot_nqp_bigint_mul_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 19 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_p_pc_p",
    "Parrot_nqp_bigint_mul_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 20 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_pc_pc_p",
    "Parrot_nqp_bigint_mul_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 21 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_p_p_pc",
    "Parrot_nqp_bigint_mul_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 22 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_pc_p_pc",
    "Parrot_nqp_bigint_mul_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 23 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_p_pc_pc",
    "Parrot_nqp_bigint_mul_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 24 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_pc_pc_pc",
    "Parrot_nqp_bigint_mul_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 25 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_p_p_p",
    "Parrot_nqp_bigint_div_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 26 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_pc_p_p",
    "Parrot_nqp_bigint_div_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 27 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_p_pc_p",
    "Parrot_nqp_bigint_div_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 28 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_pc_pc_p",
    "Parrot_nqp_bigint_div_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 29 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_p_p_pc",
    "Parrot_nqp_bigint_div_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 30 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_pc_p_pc",
    "Parrot_nqp_bigint_div_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 31 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_p_pc_pc",
    "Parrot_nqp_bigint_div_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 32 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_pc_pc_pc",
    "Parrot_nqp_bigint_div_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 33 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_p_p_p",
    "Parrot_nqp_bigint_mod_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 34 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_pc_p_p",
    "Parrot_nqp_bigint_mod_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 35 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_p_pc_p",
    "Parrot_nqp_bigint_mod_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 36 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_pc_pc_p",
    "Parrot_nqp_bigint_mod_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 37 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_p_p_pc",
    "Parrot_nqp_bigint_mod_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 38 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_pc_p_pc",
    "Parrot_nqp_bigint_mod_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 39 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_p_pc_pc",
    "Parrot_nqp_bigint_mod_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 40 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_pc_pc_pc",
    "Parrot_nqp_bigint_mod_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 41 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_p_p_p",
    "Parrot_nqp_bigint_exp_mod_p_p_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 42 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_p_p_p",
    "Parrot_nqp_bigint_exp_mod_p_pc_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 43 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_pc_p_p",
    "Parrot_nqp_bigint_exp_mod_p_p_pc_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 44 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_pc_p_p",
    "Parrot_nqp_bigint_exp_mod_p_pc_pc_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 45 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_p_pc_p",
    "Parrot_nqp_bigint_exp_mod_p_p_p_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 46 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_p_pc_p",
    "Parrot_nqp_bigint_exp_mod_p_pc_p_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 47 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_pc_pc_p",
    "Parrot_nqp_bigint_exp_mod_p_p_pc_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 48 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_pc_pc_p",
    "Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 49 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_p_p_pc",
    "Parrot_nqp_bigint_exp_mod_p_p_p_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 50 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_p_p_pc",
    "Parrot_nqp_bigint_exp_mod_p_pc_p_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 51 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_pc_p_pc",
    "Parrot_nqp_bigint_exp_mod_p_p_pc_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 52 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_pc_p_pc",
    "Parrot_nqp_bigint_exp_mod_p_pc_pc_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 53 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_p_pc_pc",
    "Parrot_nqp_bigint_exp_mod_p_p_p_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 54 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_p_pc_pc",
    "Parrot_nqp_bigint_exp_mod_p_pc_p_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 55 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_pc_pc_pc",
    "Parrot_nqp_bigint_exp_mod_p_p_pc_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 56 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_pc_pc_pc_pc",
    "Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 57 */
    "nqp_bigint_neg",
    "nqp_bigint_neg_p_p_p",
    "Parrot_nqp_bigint_neg_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 58 */
    "nqp_bigint_neg",
    "nqp_bigint_neg_p_pc_p",
    "Parrot_nqp_bigint_neg_p_pc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 59 */
    "nqp_bigint_neg",
    "nqp_bigint_neg_p_p_pc",
    "Parrot_nqp_bigint_neg_p_p_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 60 */
    "nqp_bigint_neg",
    "nqp_bigint_neg_p_pc_pc",
    "Parrot_nqp_bigint_neg_p_pc_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 61 */
    "nqp_bigint_abs",
    "nqp_bigint_abs_p_p_p",
    "Parrot_nqp_bigint_abs_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 62 */
    "nqp_bigint_abs",
    "nqp_bigint_abs_p_pc_p",
    "Parrot_nqp_bigint_abs_p_pc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 63 */
    "nqp_bigint_abs",
    "nqp_bigint_abs_p_p_pc",
    "Parrot_nqp_bigint_abs_p_p_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 64 */
    "nqp_bigint_abs",
    "nqp_bigint_abs_p_pc_pc",
    "Parrot_nqp_bigint_abs_p_pc_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 65 */
    "nqp_bigint_cmp",
    "nqp_bigint_cmp_i_p_p",
    "Parrot_nqp_bigint_cmp_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 66 */
    "nqp_bigint_cmp",
    "nqp_bigint_cmp_i_pc_p",
    "Parrot_nqp_bigint_cmp_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 67 */
    "nqp_bigint_cmp",
    "nqp_bigint_cmp_i_p_pc",
    "Parrot_nqp_bigint_cmp_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 68 */
    "nqp_bigint_cmp",
    "nqp_bigint_cmp_i_pc_pc",
    "Parrot_nqp_bigint_cmp_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 69 */
    "nqp_bigint_bool",
    "nqp_bigint_bool_i_p",
    "Parrot_nqp_bigint_bool_i_p",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 70 */
    "nqp_bigint_bool",
    "nqp_bigint_bool_i_pc",
    "Parrot_nqp_bigint_bool_i_pc",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 71 */
    "nqp_bigint_eq",
    "nqp_bigint_eq_i_p_p",
    "Parrot_nqp_bigint_eq_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 72 */
    "nqp_bigint_eq",
    "nqp_bigint_eq_i_pc_p",
    "Parrot_nqp_bigint_eq_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 73 */
    "nqp_bigint_eq",
    "nqp_bigint_eq_i_p_pc",
    "Parrot_nqp_bigint_eq_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 74 */
    "nqp_bigint_eq",
    "nqp_bigint_eq_i_pc_pc",
    "Parrot_nqp_bigint_eq_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 75 */
    "nqp_bigint_ne",
    "nqp_bigint_ne_i_p_p",
    "Parrot_nqp_bigint_ne_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 76 */
    "nqp_bigint_ne",
    "nqp_bigint_ne_i_pc_p",
    "Parrot_nqp_bigint_ne_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 77 */
    "nqp_bigint_ne",
    "nqp_bigint_ne_i_p_pc",
    "Parrot_nqp_bigint_ne_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 78 */
    "nqp_bigint_ne",
    "nqp_bigint_ne_i_pc_pc",
    "Parrot_nqp_bigint_ne_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 79 */
    "nqp_bigint_gt",
    "nqp_bigint_gt_i_p_p",
    "Parrot_nqp_bigint_gt_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 80 */
    "nqp_bigint_gt",
    "nqp_bigint_gt_i_pc_p",
    "Parrot_nqp_bigint_gt_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 81 */
    "nqp_bigint_gt",
    "nqp_bigint_gt_i_p_pc",
    "Parrot_nqp_bigint_gt_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 82 */
    "nqp_bigint_gt",
    "nqp_bigint_gt_i_pc_pc",
    "Parrot_nqp_bigint_gt_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 83 */
    "nqp_bigint_ge",
    "nqp_bigint_ge_i_p_p",
    "Parrot_nqp_bigint_ge_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 84 */
    "nqp_bigint_ge",
    "nqp_bigint_ge_i_pc_p",
    "Parrot_nqp_bigint_ge_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 85 */
    "nqp_bigint_ge",
    "nqp_bigint_ge_i_p_pc",
    "Parrot_nqp_bigint_ge_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 86 */
    "nqp_bigint_ge",
    "nqp_bigint_ge_i_pc_pc",
    "Parrot_nqp_bigint_ge_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 87 */
    "nqp_bigint_lt",
    "nqp_bigint_lt_i_p_p",
    "Parrot_nqp_bigint_lt_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 88 */
    "nqp_bigint_lt",
    "nqp_bigint_lt_i_pc_p",
    "Parrot_nqp_bigint_lt_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 89 */
    "nqp_bigint_lt",
    "nqp_bigint_lt_i_p_pc",
    "Parrot_nqp_bigint_lt_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 90 */
    "nqp_bigint_lt",
    "nqp_bigint_lt_i_pc_pc",
    "Parrot_nqp_bigint_lt_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 91 */
    "nqp_bigint_le",
    "nqp_bigint_le_i_p_p",
    "Parrot_nqp_bigint_le_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 92 */
    "nqp_bigint_le",
    "nqp_bigint_le_i_pc_p",
    "Parrot_nqp_bigint_le_i_pc_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 93 */
    "nqp_bigint_le",
    "nqp_bigint_le_i_p_pc",
    "Parrot_nqp_bigint_le_i_p_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 94 */
    "nqp_bigint_le",
    "nqp_bigint_le_i_pc_pc",
    "Parrot_nqp_bigint_le_i_pc_pc",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 95 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_p_p_p",
    "Parrot_nqp_bigint_gcd_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 96 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_pc_p_p",
    "Parrot_nqp_bigint_gcd_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 97 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_p_pc_p",
    "Parrot_nqp_bigint_gcd_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 98 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_pc_pc_p",
    "Parrot_nqp_bigint_gcd_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 99 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_p_p_pc",
    "Parrot_nqp_bigint_gcd_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 100 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_pc_p_pc",
    "Parrot_nqp_bigint_gcd_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 101 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_p_pc_pc",
    "Parrot_nqp_bigint_gcd_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 102 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_pc_pc_pc",
    "Parrot_nqp_bigint_gcd_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 103 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_p_p_p",
    "Parrot_nqp_bigint_lcm_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 104 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_pc_p_p",
    "Parrot_nqp_bigint_lcm_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 105 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_p_pc_p",
    "Parrot_nqp_bigint_lcm_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 106 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_pc_pc_p",
    "Parrot_nqp_bigint_lcm_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 107 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_p_p_pc",
    "Parrot_nqp_bigint_lcm_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 108 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_pc_p_pc",
    "Parrot_nqp_bigint_lcm_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 109 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_p_pc_pc",
    "Parrot_nqp_bigint_lcm_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 110 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_pc_pc_pc",
    "Parrot_nqp_bigint_lcm_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 111 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_s_p",
    "Parrot_nqp_bigint_from_str_p_s_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_S, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 112 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_sc_p",
    "Parrot_nqp_bigint_from_str_p_sc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_SC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 113 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_s_pc",
    "Parrot_nqp_bigint_from_str_p_s_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_S, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 114 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_sc_pc",
    "Parrot_nqp_bigint_from_str_p_sc_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_SC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 115 */
    "nqp_bigint_to_str",
    "nqp_bigint_to_str_s_p",
    "Parrot_nqp_bigint_to_str_s_p",
    0,
    3,
    { PARROT_ARG_S, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 116 */
    "nqp_bigint_to_str",
    "nqp_bigint_to_str_s_pc",
    "Parrot_nqp_bigint_to_str_s_pc",
    0,
    3,
    { PARROT_ARG_S, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 117 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_p_i",
    "Parrot_nqp_bigint_to_str_base_s_p_i",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_P, PARROT_ARG_I },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 118 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_pc_i",
    "Parrot_nqp_bigint_to_str_base_s_pc_i",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_PC, PARROT_ARG_I },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 119 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_p_ic",
    "Parrot_nqp_bigint_to_str_base_s_p_ic",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_P, PARROT_ARG_IC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 120 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_pc_ic",
    "Parrot_nqp_bigint_to_str_base_s_pc_ic",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_PC, PARROT_ARG_IC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 121 */
    "nqp_bigint_to_num",
    "nqp_bigint_to_num_n_p",
    "Parrot_nqp_bigint_to_num_n_p",
    0,
    3,
    { PARROT_ARG_N, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 122 */
    "nqp_bigint_to_num",
    "nqp_bigint_to_num_n_pc",
    "Parrot_nqp_bigint_to_num_n_pc",
    0,
    3,
    { PARROT_ARG_N, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 123 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_n_p",
    "Parrot_nqp_bigint_from_num_p_n_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_N, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 124 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_nc_p",
    "Parrot_nqp_bigint_from_num_p_nc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_NC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 125 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_n_pc",
    "Parrot_nqp_bigint_from_num_p_n_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_N, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 126 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_nc_pc",
    "Parrot_nqp_bigint_from_num_p_nc_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_NC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 127 */
    "nqp_bigint_div_num",
    "nqp_bigint_div_num_n_p_p",
    "Parrot_nqp_bigint_div_num_n_p_p",
    0,
    4,
    { PARROT_ARG_N, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 128 */
    "nqp_bigint_div_num",
    "nqp_bigint_div_num_n_pc_p",
    "Parrot_nqp_bigint_div_num_n_pc_p",
    0,
    4,
    { PARROT_ARG_N, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 129 */
    "nqp_bigint_div_num",
    "nqp_bigint_div_num_n_p_pc",
    "Parrot_nqp_bigint_div_num_n_p_pc",
    0,
    4,
    { PARROT_ARG_N, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 130 */
    "nqp_bigint_div_num",
    "nqp_bigint_div_num_n_pc_pc",
    "Parrot_nqp_bigint_div_num_n_pc_pc",
    0,
    4,
    { PARROT_ARG_N, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 131 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_i_p",
    "Parrot_nqp_bigint_shr_p_p_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 132 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_pc_i_p",
    "Parrot_nqp_bigint_shr_p_pc_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 133 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_ic_p",
    "Parrot_nqp_bigint_shr_p_p_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 134 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_pc_ic_p",
    "Parrot_nqp_bigint_shr_p_pc_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 135 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_i_pc",
    "Parrot_nqp_bigint_shr_p_p_i_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 136 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_pc_i_pc",
    "Parrot_nqp_bigint_shr_p_pc_i_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 137 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_ic_pc",
    "Parrot_nqp_bigint_shr_p_p_ic_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 138 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_pc_ic_pc",
    "Parrot_nqp_bigint_shr_p_pc_ic_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 139 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_i_p",
    "Parrot_nqp_bigint_shl_p_p_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 140 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_pc_i_p",
    "Parrot_nqp_bigint_shl_p_pc_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 141 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_ic_p",
    "Parrot_nqp_bigint_shl_p_p_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 142 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_pc_ic_p",
    "Parrot_nqp_bigint_shl_p_pc_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 143 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_i_pc",
    "Parrot_nqp_bigint_shl_p_p_i_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 144 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_pc_i_pc",
    "Parrot_nqp_bigint_shl_p_pc_i_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 145 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_ic_pc",
    "Parrot_nqp_bigint_shl_p_p_ic_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 146 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_pc_ic_pc",
    "Parrot_nqp_bigint_shl_p_pc_ic_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 147 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_p_p_p",
    "Parrot_nqp_bigint_band_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 148 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_pc_p_p",
    "Parrot_nqp_bigint_band_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 149 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_p_pc_p",
    "Parrot_nqp_bigint_band_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 150 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_pc_pc_p",
    "Parrot_nqp_bigint_band_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 151 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_p_p_pc",
    "Parrot_nqp_bigint_band_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 152 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_pc_p_pc",
    "Parrot_nqp_bigint_band_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 153 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_p_pc_pc",
    "Parrot_nqp_bigint_band_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 154 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_pc_pc_pc",
    "Parrot_nqp_bigint_band_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 155 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_p_p_p",
    "Parrot_nqp_bigint_bor_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 156 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_pc_p_p",
    "Parrot_nqp_bigint_bor_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 157 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_p_pc_p",
    "Parrot_nqp_bigint_bor_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 158 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_pc_pc_p",
    "Parrot_nqp_bigint_bor_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 159 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_p_p_pc",
    "Parrot_nqp_bigint_bor_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 160 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_pc_p_pc",
    "Parrot_nqp_bigint_bor_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 161 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_p_pc_pc",
    "Parrot_nqp_bigint_bor_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 162 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_pc_pc_pc",
    "Parrot_nqp_bigint_bor_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 163 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_p_p_p",
    "Parrot_nqp_bigint_bxor_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 164 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_pc_p_p",
    "Parrot_nqp_bigint_bxor_p_pc_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 165 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_p_pc_p",
    "Parrot_nqp_bigint_bxor_p_p_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 166 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_pc_pc_p",
    "Parrot_nqp_bigint_bxor_p_pc_pc_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 167 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_p_p_pc",
    "Parrot_nqp_bigint_bxor_p_p_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 168 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_pc_p_pc",
    "Parrot_nqp_bigint_bxor_p_pc_p_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 169 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_p_pc_pc",
    "Parrot_nqp_bigint_bxor_p_p_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 170 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_pc_pc_pc",
    "Parrot_nqp_bigint_bxor_p_pc_pc_pc",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 171 */
    "nqp_bigint_bnot",
    "nqp_bigint_bnot_p_p_p",
    "Parrot_nqp_bigint_bnot_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 172 */
    "nqp_bigint_bnot",
    "nqp_bigint_bnot_p_pc_p",
    "Parrot_nqp_bigint_bnot_p_pc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 173 */
    "nqp_bigint_bnot",
    "nqp_bigint_bnot_p_p_pc",
    "Parrot_nqp_bigint_bnot_p_p_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 174 */
    "nqp_bigint_bnot",
    "nqp_bigint_bnot_p_pc_pc",
    "Parrot_nqp_bigint_bnot_p_pc_pc",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 175 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_i_p",
    "Parrot_nqp_bigint_radix_p_i_s_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 176 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_i_p",
    "Parrot_nqp_bigint_radix_p_ic_s_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 177 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_i_p",
    "Parrot_nqp_bigint_radix_p_i_sc_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 178 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_i_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 179 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_i_p",
    "Parrot_nqp_bigint_radix_p_i_s_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 180 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_i_p",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 181 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_i_p",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 182 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_i_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 183 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_ic_p",
    "Parrot_nqp_bigint_radix_p_i_s_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 184 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_s_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 185 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_ic_p",
    "Parrot_nqp_bigint_radix_p_i_sc_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 186 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 187 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_i_s_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 188 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 189 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 190 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 191 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_i_pc",
    "Parrot_nqp_bigint_radix_p_i_s_i_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 192 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_i_pc",
    "Parrot_nqp_bigint_radix_p_ic_s_i_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 193 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_i_pc",
    "Parrot_nqp_bigint_radix_p_i_sc_i_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 194 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_i_pc",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 195 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_i_pc",
    "Parrot_nqp_bigint_radix_p_i_s_ic_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 196 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_i_pc",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 197 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_i_pc",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 198 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_i_pc",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_i_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 199 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_ic_pc",
    "Parrot_nqp_bigint_radix_p_i_s_i_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 200 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_ic_pc",
    "Parrot_nqp_bigint_radix_p_ic_s_i_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 201 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_ic_pc",
    "Parrot_nqp_bigint_radix_p_i_sc_i_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 202 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_ic_pc",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 203 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_ic_pc",
    "Parrot_nqp_bigint_radix_p_i_s_ic_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 204 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_ic_pc",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 205 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_ic_pc",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 206 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_ic_pc",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_pc",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 207 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_p_p_p",
    "Parrot_nqp_bigint_pow_p_p_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 208 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_p_p_p",
    "Parrot_nqp_bigint_pow_p_pc_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 209 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_pc_p_p",
    "Parrot_nqp_bigint_pow_p_p_pc_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 210 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_pc_p_p",
    "Parrot_nqp_bigint_pow_p_pc_pc_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 211 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_p_pc_p",
    "Parrot_nqp_bigint_pow_p_p_p_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 212 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_p_pc_p",
    "Parrot_nqp_bigint_pow_p_pc_p_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 213 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_pc_pc_p",
    "Parrot_nqp_bigint_pow_p_p_pc_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 214 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_pc_pc_p",
    "Parrot_nqp_bigint_pow_p_pc_pc_pc_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 215 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_p_p_pc",
    "Parrot_nqp_bigint_pow_p_p_p_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 216 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_p_p_pc",
    "Parrot_nqp_bigint_pow_p_pc_p_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 217 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_pc_p_pc",
    "Parrot_nqp_bigint_pow_p_p_pc_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 218 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_pc_p_pc",
    "Parrot_nqp_bigint_pow_p_pc_pc_p_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 219 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_p_pc_pc",
    "Parrot_nqp_bigint_pow_p_p_p_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 220 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_p_pc_pc",
    "Parrot_nqp_bigint_pow_p_pc_p_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 221 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_pc_pc_pc",
    "Parrot_nqp_bigint_pow_p_p_pc_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 222 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_pc_pc_pc_pc",
    "Parrot_nqp_bigint_pow_p_pc_pc_pc_pc",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 223 */
    "nqp_bigint_is_big",
    "nqp_bigint_is_big_i_p",
    "Parrot_nqp_bigint_is_big_i_p",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 224 */
    "nqp_bigint_is_big",
    "nqp_bigint_is_big_i_pc",
    "Parrot_nqp_bigint_is_big_i_pc",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_PC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },

};


/*
** Op Function Definitions:
*/

opcode_t *
Parrot_nqp_bigint_setup(opcode_t *cur_opcode, PARROT_INTERP) {
    if ((!bigint_repr_id)) {
        bigint_repr_id = REGISTER_DYNAMIC_REPR(interp, Parrot_str_new_constant(interp, "P6bigint"), P6bigint_initialize);
    }

    return cur_opcode + 1;
}

opcode_t *
Parrot_nqp_bigint_add_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_add_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   result;

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   result;

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   result;

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   result;

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   result;

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   result;

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   result;

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   result;

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_pc_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    mp_int  * c = get_bigint(interp, PCONST(4));

    PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_neg_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_neg(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_neg_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_neg(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_neg_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_neg(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_neg_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_neg(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_abs_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_abs(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_abs_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_abs(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_abs_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_abs(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_abs_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_abs(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_cmp_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = mp_cmp(a, b);
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_cmp_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = mp_cmp(a, b);
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_cmp_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = mp_cmp(a, b);
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_cmp_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = mp_cmp(a, b);
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_bool_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    IREG(1) = (!mp_iszero(get_bigint(interp, PREG(2))));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_bool_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    IREG(1) = (!mp_iszero(get_bigint(interp, PCONST(2))));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_eq_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_eq_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_eq_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_EQ == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_eq_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_EQ == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ne_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ne_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ne_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_EQ != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ne_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_EQ != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gt_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gt_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gt_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_GT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gt_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_GT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ge_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ge_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ge_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_LT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ge_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_LT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_lt_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_lt_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_lt_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_LT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_lt_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_LT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_le_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_le_i_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_le_i_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_GT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_le_i_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    IREG(1) = (MP_GT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_s_p(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_sc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SCONST(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_s_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SREG(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_sc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SCONST(2));

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_s_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, 10, (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, 10, len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_to_str_s_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PCONST(2));
    int   len;
    char  * buf;

    mp_radix_size(i, 10, (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, 10, len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_p_i(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, IREG(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, IREG(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_pc_i(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PCONST(2));
    int   len;
    char  * buf;

    mp_radix_size(i, IREG(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, IREG(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_p_ic(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, ICONST(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, ICONST(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_pc_ic(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PCONST(2));
    int   len;
    char  * buf;

    mp_radix_size(i, ICONST(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, ICONST(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_num_n_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int   * a = get_bigint(interp, PREG(2));

    NREG(1) = mp_get_double(a);
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_to_num_n_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int   * a = get_bigint(interp, PCONST(2));

    NREG(1) = mp_get_double(a);
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_n_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NREG(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_nc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NCONST(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_n_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NREG(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_nc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NCONST(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_div_num_n_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   max_size = (DIGIT_BIT * MAX(USED(a), USED(b)));

    if ((max_size > 1023)) {
        mp_int   reduced_a;
        mp_int   reduced_b;

        mp_init((&reduced_a));
        mp_init((&reduced_b));
        mp_div_2d(a, (max_size - 1023), (&reduced_a), NULL);
        mp_div_2d(b, (max_size - 1023), (&reduced_b), NULL);
        NREG(1) = (mp_get_double((&reduced_a)) / mp_get_double((&reduced_b)));
        mp_clear((&reduced_a));
        mp_clear((&reduced_b));
    }
    else {
        NREG(1) = (mp_get_double(a) / mp_get_double(b));
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_div_num_n_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   max_size = (DIGIT_BIT * MAX(USED(a), USED(b)));

    if ((max_size > 1023)) {
        mp_int   reduced_a;
        mp_int   reduced_b;

        mp_init((&reduced_a));
        mp_init((&reduced_b));
        mp_div_2d(a, (max_size - 1023), (&reduced_a), NULL);
        mp_div_2d(b, (max_size - 1023), (&reduced_b), NULL);
        NREG(1) = (mp_get_double((&reduced_a)) / mp_get_double((&reduced_b)));
        mp_clear((&reduced_a));
        mp_clear((&reduced_b));
    }
    else {
        NREG(1) = (mp_get_double(a) / mp_get_double(b));
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_div_num_n_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   max_size = (DIGIT_BIT * MAX(USED(a), USED(b)));

    if ((max_size > 1023)) {
        mp_int   reduced_a;
        mp_int   reduced_b;

        mp_init((&reduced_a));
        mp_init((&reduced_b));
        mp_div_2d(a, (max_size - 1023), (&reduced_a), NULL);
        mp_div_2d(b, (max_size - 1023), (&reduced_b), NULL);
        NREG(1) = (mp_get_double((&reduced_a)) / mp_get_double((&reduced_b)));
        mp_clear((&reduced_a));
        mp_clear((&reduced_b));
    }
    else {
        NREG(1) = (mp_get_double(a) / mp_get_double(b));
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_div_num_n_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));
    int   max_size = (DIGIT_BIT * MAX(USED(a), USED(b)));

    if ((max_size > 1023)) {
        mp_int   reduced_a;
        mp_int   reduced_b;

        mp_init((&reduced_a));
        mp_init((&reduced_b));
        mp_div_2d(a, (max_size - 1023), (&reduced_a), NULL);
        mp_div_2d(b, (max_size - 1023), (&reduced_b), NULL);
        NREG(1) = (mp_get_double((&reduced_a)) / mp_get_double((&reduced_b)));
        mp_clear((&reduced_a));
        mp_clear((&reduced_b));
    }
    else {
        NREG(1) = (mp_get_double(a) / mp_get_double(b));
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, IREG(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_pc_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, IREG(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, ICONST(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_pc_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, ICONST(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, IREG(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_pc_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, IREG(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, ICONST(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_pc_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, ICONST(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, IREG(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_pc_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, IREG(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, ICONST(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_pc_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, ICONST(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, IREG(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_pc_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, IREG(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, ICONST(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_pc_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PCONST(2));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, ICONST(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b = get_bigint(interp, PCONST(3));

    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bnot_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b;

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_add_d(a, 1, b);
    mp_neg(b, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_bnot_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b;

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_add_d(a, 1, b);
    mp_neg(b, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_bnot_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b;

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_add_d(a, 1, b);
    mp_neg(b, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_bnot_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));
    mp_int  * b;

    PREG(1) = REPR(PCONST(3))->allocate(interp, STABLE(PCONST(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_add_d(a, 1, b);
    mp_neg(b, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PCONST(6))->allocate(interp, STABLE(PCONST(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_pc_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_p_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_pc_pc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_p_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_pc_p_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_p_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_pow_p_pc_pc_pc_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PCONST(3));
    mp_int  * base = get_bigint(interp, PCONST(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PCONST(2))->allocate(interp, STABLE(PCONST(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PCONST(5))->allocate(interp, STABLE(PCONST(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PCONST(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PCONST(4))->allocate(interp, STABLE(PCONST(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_is_big_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    IREG(1) = (a->used > 1);
    if ((((((sizeof(INTVAL) * 8) < DIGIT_BIT) && (IREG(1) == 0)) && DIGIT(a, 0)) & (~0x7FFFFFFFUL))) {
        IREG(1) = 1;
    }

    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_is_big_i_pc(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PCONST(2));

    IREG(1) = (a->used > 1);
    if ((((((sizeof(INTVAL) * 8) < DIGIT_BIT) && (IREG(1) == 0)) && DIGIT(a, 0)) & (~0x7FFFFFFFUL))) {
        IREG(1) = 1;
    }

    return cur_opcode + 3;
}


/*
** op lib descriptor:
*/

/* XXX should be static, but C++ doesn't want to play ball */
op_lib_t nqp_bigint_op_lib = {
  "nqp_bigint_ops",                /* name */
  "",                  /* suffix */
  PARROT_FUNCTION_CORE,                       /* core_type = PARROT_XX_CORE */
  0,                                /* flags */
  4,    /* major_version */
  7,    /* minor_version */
  0,    /* patch_version */
  225,             /* op_count */
  nqp_bigint_op_info_table,       /* op_info_table */
  nqp_bigint_op_func_table,       /* op_func_table */
  get_op          /* op_code() */ 
};

/*
** Op lookup function:
*/

#define OP_HASH_SIZE 3041

/* we could calculate a prime somewhat bigger than
 * n of fullnames + n of names
 * for now this should be ok
 *
 * look up an op_code: at first call to op_code() a hash
 * of short and full opcode names is created
 * hash functions are from imcc, thanks to Melvin.
 */


typedef struct hop {
    op_info_t * info;
    struct hop *next;
} HOP;

static HOP *hop_buckets;
static HOP **hop;

static void hop_init(PARROT_INTERP);
static size_t hash_str(ARGIN(const char *str));
static void store_op(ARGIN(op_info_t *info), ARGMOD(HOP *p), ARGIN(const char *name));

/* XXX on changing interpreters, this should be called,
   through a hook */

static void hop_deinit(PARROT_INTERP);

/*
 * find a short or full opcode
 * usage:
 *
 * interp->op_lib->op_code("set", 0)
 * interp->op_lib->op_code("set_i_i", 1)
 *
 * returns >= 0 (found idx into info_table), -1 if not
 */

PARROT_PURE_FUNCTION
static
size_t hash_str(ARGIN(const char *str))
{
    size_t      key = 0;
    const char *s   = str;

    while (*s) {
        key *= 65599;
        key += *s++;
    }

    return key;
}


static void store_op(ARGIN(op_info_t *info), ARGMOD(HOP *p), ARGIN(const char *name))
{
    const size_t hidx = hash_str(name) % OP_HASH_SIZE;

    p->info           = info;
    p->next           = hop[hidx];
    hop[hidx]         = p;
}

static int get_op(PARROT_INTERP, ARGIN(const char *name), int full)
{
    const HOP   *p;
    const size_t hidx = hash_str(name) % OP_HASH_SIZE;

    if (!hop) {
        hop = mem_gc_allocate_n_zeroed_typed(interp, OP_HASH_SIZE,HOP *);
        hop_init(interp);
    }

    for (p = hop[hidx]; p; p = p->next) {
        if (STREQ(name, full ? p->info->full_name : p->info->name))
            return p->info - nqp_bigint_op_lib.op_info_table;
    }

    return -1;
}


static void hop_init(PARROT_INTERP)
{
    op_info_t * const info = nqp_bigint_op_lib.op_info_table;
    opcode_t i;

    /* allocate the storage all in one chunk
     * yes, this is profligate, but we can tighten it later */
    HOP *hops;

    hop_buckets = mem_gc_allocate_n_zeroed_typed(interp, nqp_bigint_op_lib.op_count * 2, HOP );
    hops        = hop_buckets;


    /* store full names */
    for (i = 0; i < nqp_bigint_op_lib.op_count; i++) {
        store_op(info + i, hops++, info[i].full_name);

        /* plus one short name */
        if (i && info[i - 1].name != info[i].name)
            store_op(info + i, hops++, info[i].name);
    }
}

static void hop_deinit(PARROT_INTERP)
{
    if (hop)
        mem_sys_free(hop);
    if (hop_buckets)
        mem_gc_free(interp, hop_buckets);

    hop         = NULL;
    hop_buckets = NULL;
}
op_lib_t *
Parrot_DynOp_nqp_bigint_4_7_0(PARROT_INTERP, long init) {
    /* initialize and return op_lib ptr */
    if (init == 1) {

        return &nqp_bigint_op_lib;
    }
    /* set op_lib to the passed ptr (in init) */
    else if (init) {

    }
    /* deinit - free resources */
    else {
        hop_deinit(interp);
    }
    return NULL;
}


/*
 * dynamic lib load function - called once
 */
PARROT_DYNEXT_EXPORT PMC*
Parrot_lib_nqp_bigint_ops_load(PARROT_INTERP);

PARROT_DYNEXT_EXPORT PMC*
Parrot_lib_nqp_bigint_ops_load(PARROT_INTERP)

{
    PMC *const lib = Parrot_pmc_new(interp, enum_class_ParrotLibrary);
    ((Parrot_ParrotLibrary_attributes*)PMC_data(lib))->oplib_init = (void *) Parrot_DynOp_nqp_bigint_4_7_0;
    dynop_register(interp, lib);
    return lib;
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 *   buffer-read-only: t
 * End:
 * vim: expandtab shiftwidth=4:
 */
